=== debian/changelog ===
mudlet (1:3.0.0~rc7iota-1) unstable; urgency=medium

  * New upstream release

 -- Craig Small <csmall@debian.org>  Tue, 22 Nov 2016 22:12:53 +1100
