## mudlet 3.0.1

=== debian/changelog ===
mudlet (1:3.0.1-1) unstable; urgency=medium

  * New upstream release
  * Added lua zip and filesystem dependencies

 -- Craig Small <csmall@debian.org>  Fri, 14 Apr 2017 07:14:11 +1000

mudlet (1:3.0.0-2) unstable; urgency=medium

  * Remove upstream Makefile Closes: #858730

 -- Craig Small <csmall@debian.org>  Sun, 26 Mar 2017 08:15:59 +1100

mudlet (1:3.0.0-1) unstable; urgency=medium

  * Upstream 3.0.0 finally released!

 -- Craig Small <csmall@debian.org>  Sat, 25 Mar 2017 13:20:13 +1100
