## mudlet 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,34 +18,39 @@
 #    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
 ############################################################################
 
+# Should be called before PROJECT.
+CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
+
 PROJECT(mudlet)
 
-# Windows builds need 2.8.11, but for other platforms 2.8.9 should be enough
-IF(MSVC)
-  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
+IF(CMAKE_CONFIGURATION_TYPES)
+  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND}
+                    --force-new-ctest-process --output-on-failure
+                    --build-config "$<CONFIGURATION>")
 ELSE()
-  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.9)
+  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND}
+                    --force-new-ctest-process --output-on-failure)
 ENDIF()
+
+ENABLE_TESTING()
 
 IF(POLICY CMP0020)
   CMAKE_POLICY(SET CMP0020 NEW)
 ENDIF()
 
 IF(WIN32)
-    SET(APP_TARGET mudlet.exe)
+  SET(APP_TARGET mudlet.exe)
 ELSEIF(APPLE)
-    SET(APP_TARGET Mudlet)
+  SET(APP_TARGET Mudlet)
 ELSE()
-    SET(APP_TARGET mudlet)
+  SET(APP_TARGET mudlet)
 ENDIF()
 
-SET(APP_VERSION 3.0.0)
-SET(APP_BUILD "-iota")
 # APP_BUILD should only be empty/null in official "release" builds,
-# developers may like to set it to their user and branch names to make it easier
-# to tell different builds apart!
+# developers may like to set the MUDLET_VERSION_BUILD environment variable to
+# their user and branch names to make it easier to tell different builds apart!
 #
-# Changing the above pair of values affects: ctelnet.cpp, main.cpp, mudlet.cpp
+# Changing this pair of values affects: ctelnet.cpp, main.cpp, mudlet.cpp
 # dlgAboutDialog.cpp and TLuaInterpreter.cpp.  It will not necessarily cause
 # those files to be automatically rebuilt so you may need to 'touch' those files if
 # the variables are changed and you are not doing a full, clean, rebuild!
@@ -54,5 +59,20 @@
 # To insure consistency please ensure the SAME of the first two values are also
 # assigned to the "VERSION" and "BUILD" variables in the native qmake project file,
 # i.e. ./src/src.pro
+SET(APP_VERSION 3.2.0)
+IF(DEFINED ENV{MUDLET_VERSION_BUILD} AND NOT $ENV{MUDLET_VERSION_BUILD} STREQUAL "")
+  SET(APP_BUILD $ENV{MUDLET_VERSION_BUILD})
+else()
+  SET(APP_BUILD "")
+ENDIF()
+
+SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
+
+ADD_SUBDIRECTORY(3rdparty/communi)
+ADD_SUBDIRECTORY(3rdparty/lua_yajl)
+# Needed (just) on MacOs as an #include in luazip.h:
+IF(APPLE)
+  ADD_SUBDIRECTORY(3rdparty/luazip)
+ENDIF()
 
 ADD_SUBDIRECTORY(src)
