=== debian/changelog ===
mudlet (1:3.2.0-1build1) artful; urgency=medium

  * No-change rebuild against latest hunspell

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 20 Jun 2017 05:07:50 -0400

mudlet (1:3.2.0-1) unstable; urgency=medium

  * New upstream release
  * Removed luaglobal patch, using the upstream path logic

 -- Craig Small <csmall@debian.org>  Thu, 08 Jun 2017 22:02:36 +1000
