=== debian/control ===
--- 
+++ 
@@ -15,7 +15,9 @@
 
 Package: mudlet
 Architecture: alpha amd64 arm64 hppa i386 ia64 m32r m68k mips mipsel powerpc ppc64 ppc64el s390 s390x sh3 sh3eb sparc sparc64 x32
-Depends: ${shlibs:Depends}, ${misc:Depends}, lua5.1-rex-pcre, lua5.1-sql-sqlite3
+Depends: ${shlibs:Depends}, ${misc:Depends},
+         lua5.1-rex-pcre, lua5.1-sql-sqlite3,
+         lua-filesystem, lua-zip
 Suggests: hunspell-en-us
 Description: Graphical MUD client with fast lua scripting support
  A completely redesigned MUD (Multi User Dungeon) client that is easy to
